Index: /palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- /palm/trunk/SOURCE/init_3d_model.f90	(revision 3050)
+++ /palm/trunk/SOURCE/init_3d_model.f90	(revision 3051)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Move initialization call for nudging and 1D/3D offline nesting. 
+! Revise initialization with inifor data.
+! 
+! 3045 2018-05-28 07:55:41Z Giersch
 ! Error messages revised
 ! 
@@ -1116,16 +1120,4 @@
 
 !
-!-- Initialize nudging if required
-    IF ( nudging )  THEN
-       CALL nudge_init
-    ENDIF
-
-!
-!-- Initialize reading of large scale forcing from external file - if required
-    IF ( large_scale_forcing  .OR.  forcing )  THEN
-       CALL lsf_init
-    ENDIF
-
-!
 !-- Allocate arrays containing the RK coefficient for calculation of 
 !-- perturbation pressure and turbulent fluxes. At this point values are
@@ -1166,5 +1158,6 @@
           CALL location_message( 'initializing with INIFOR', .FALSE. )
 !
-!--       Read initial 1D profiles from NetCDF file if available. 
+!--       Read initial 1D profiles or 3D data from NetCDF file, depending 
+!--       on the provided level-of-detail. 
 !--       At the moment, only u, v, w, pt and q are provided. 
           CALL netcdf_data_input_init_3d
@@ -1177,19 +1170,27 @@
           IF ( ANY( zu(1:nzt+1) /= init_3d%zu_atmos(1:init_3d%nzu) ) )  THEN
 
-             CALL netcdf_data_input_interpolate( init_3d%u_init(nzb+1:nzt+1),  &
+             IF( init_3d%lod_u == 1 )                                          &
+                CALL netcdf_data_input_interpolate(                            &
+                                                 init_3d%u_init(nzb+1:nzt+1),  &
                                                  zu(nzb+1:nzt+1),              &
                                                  init_3d%zu_atmos )
-             CALL netcdf_data_input_interpolate( init_3d%v_init(nzb+1:nzt+1),  &
+                                                 
+             IF( init_3d%lod_v == 1 )                                          &
+                CALL netcdf_data_input_interpolate(                            &
+                                                 init_3d%v_init(nzb+1:nzt+1),  &
                                                  zu(nzb+1:nzt+1),              &
                                                  init_3d%zu_atmos )
+                                                 
 !              CALL netcdf_data_input_interpolate( init_3d%w_init(nzb+1:nzt),    &
 !                                                  zw(nzb+1:nzt),                &
 !                                                  init_3d%zw_atmos )
-             IF ( .NOT. neutral )                                              &
+
+             IF ( .NOT. neutral  .AND.  init_3d%lod_pt == 1 )                  &
                 CALL netcdf_data_input_interpolate(                            &
                                              init_3d%pt_init(nzb+1:nzt+1),     &
                                              zu(nzb+1:nzt+1),                  &
                                              init_3d%zu_atmos )
-             IF ( humidity )                                                   &
+                                             
+             IF ( humidity  .AND.  init_3d%lod_q == 1 )                        &
                 CALL netcdf_data_input_interpolate(                            &
                                              init_3d%q_init(nzb+1:nzt+1),      &
@@ -1197,9 +1198,12 @@
                                              init_3d%zu_atmos )
           ENDIF
-
-          u_init = init_3d%u_init
-          v_init = init_3d%v_init    
-          IF( .NOT. neutral )  pt_init = init_3d%pt_init
-          IF( humidity      )  q_init  = init_3d%q_init
+!
+!--       In case of LOD=1, initialize 1D profiles and 3D data.  
+          IF( init_3d%lod_u == 1 )  u_init = init_3d%u_init
+          IF( init_3d%lod_v == 1 )  v_init = init_3d%v_init    
+          IF( .NOT. neutral  .AND.  init_3d%lod_pt == 1 )                      &
+             pt_init = init_3d%pt_init
+          IF( humidity  .AND.  init_3d%lod_q == 1 )                            &
+             q_init  = init_3d%q_init
 
 !
@@ -1210,8 +1214,10 @@
           DO  i = nxlg, nxrg
              DO  j = nysg, nyng
-                u(:,j,i) = u_init(:)
-                v(:,j,i) = v_init(:)
-                IF( .NOT. neutral )  pt(:,j,i) = pt_init(:)
-                IF( humidity      )  q(:,j,i)  = q_init(:)
+                IF( init_3d%lod_u == 1 )  u(:,j,i) = u_init(:)
+                IF( init_3d%lod_v == 1 )  v(:,j,i) = v_init(:)
+                IF( .NOT. neutral  .AND.  init_3d%lod_pt == 1 )                &
+                   pt(:,j,i) = pt_init(:)
+                IF( humidity  .AND.  init_3d%lod_q == 1 )                      &
+                   q(:,j,i)  = q_init(:)
              ENDDO
           ENDDO
@@ -2287,4 +2293,13 @@
 
 !
+!-- Initialize nudging if required
+    IF ( nudging )  CALL nudge_init
+
+!
+!-- Initialize 1D/3D offline-nesting with COSMO model and read data from 
+!-- external file.
+    IF ( large_scale_forcing  .OR.  forcing )  CALL lsf_init
+    
+!
 !-- Initialize surface forcing corresponding to large-scale forcing. Therein, 
 !-- initialize heat-fluxes, etc. via datatype. Revise it later!
Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 3050)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 3051)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Minor bugfix concerning mapping 3D buildings on top of terrain
+! 
+! 3045 2018-05-28 07:55:41Z Giersch
 ! Error messages revised
 ! 
@@ -926,4 +929,8 @@
     topo_3d(nzb,:,:) = IBCLR( topo_3d(nzb,:,:), 0 )
 !
+!-- In order to map topography on PALM grid also in case of ocean simulations,
+!-- pre-calculate an offset value.
+    ocean_offset = MERGE( zw(0), 0.0_wp, ocean )
+!
 !-- Reference buildings on top of orography. This is not necessary
 !-- if topography is read from ASCII file as no distinction between buildings
@@ -1038,6 +1045,6 @@
 
 !
-!--       Finally, determine maximumum terrain height occupied by the 
-!--       respective building. 
+!--       Determine maximumum terrain height occupied by the respective 
+!--       building and temporalily store on oro_max 
           ALLOCATE( oro_max_l(1:SIZE(build_ids_final)) )
           ALLOCATE( oro_max(1:SIZE(build_ids_final))   )
@@ -1059,9 +1066,18 @@
           oro_max = oro_max_l
 #endif
+!
+!--       Finally, determine discrete grid height of maximum orography occupied
+!--       by a building. Use all-or-nothing approach, i.e. a grid box is either
+          oro_max_l = 0.0
+          DO  nr = 1, SIZE(build_ids_final)
+             DO  k = nzb, nzt
+                IF ( zu(k) - ocean_offset <= oro_max(nr) )                     &
+                   oro_max_l = zw(k) - ocean_offset
+             ENDDO
+             oro_max = oro_max_l
+          ENDDO
        ENDIF
 !
 !--    Map orography as well as buildings onto grid. 
-!--    In case of ocean simulations, add an offset.  
-       ocean_offset = MERGE( zw(0), 0.0_wp, ocean )
        DO  i = nxl, nxr
           DO  j = nys, nyn
@@ -1080,5 +1096,5 @@
                     topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
                     topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 1 )
-                    topo_top_index = topo_top_index + 1
+                    topo_top_index = k ! topo_top_index + 1
                 ENDIF
 !
@@ -1116,16 +1132,25 @@
                                      building_id_f%var(j,i) ), DIM = 1 )
 !
-!--                Extend building down to the terrain surface.
-                   k2 = topo_top_index
+!--                Extend building down to the terrain surface, i.e. fill-up
+!--                surface irregularities below a building. Note, oro_max
+!--                is already a discrete height according to the all-or-nothing
+!--                approach, i.e. grid box is either topography or atmosphere, 
+!--                terrain top is defined at upper bound of the grid box.
+!--                Hence, check for zw in this case. 
                    DO k = topo_top_index + 1, nzt + 1      
-                      IF ( zu(k) - ocean_offset <= oro_max(nr) )  THEN
+                      IF ( zw(k) - ocean_offset <= oro_max(nr) )  THEN
                          topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
                          topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 2 )
-                         k2             = k2 + 1
                       ENDIF
-                   ENDDO    
-                   topo_top_index = k2       
-!
-!--                Now, map building on top. 
+                   ENDDO        
+!
+!--                After surface irregularities are smoothen, determine lower
+!--                start index where building starts. 
+                   DO  k = nzb, nzt
+                      IF ( zw(k) - ocean_offset <= oro_max(nr) )               &
+                         topo_top_index = k
+                   ENDDO
+!
+!--                Finally, map building on top.
                    k2 = 0
                    DO k = topo_top_index, nzt + 1
Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 3051)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Bugfix in surface-element loops for pavement surfaces 
+! 
+! 3045 2018-05-28 07:55:41Z Giersch
 ! Error messages revised
 ! 
@@ -3788,6 +3791,6 @@
                    surf_lsm_v(l)%emissivity(ind_pav_green,m)  =                &
                                               pavement_pars(ind_p_emis,st)    
-
-                   DO  k = nzb_soil, surf_lsm_h%nzt_pavement(m)
+                                              
+                   DO  k = nzb_soil, surf_lsm_v(l)%nzt_pavement(m)
                       surf_lsm_v(l)%lambda_h_def(k,m)    =                     &
                                     pavement_subsurface_pars_1(k,pavement_type)                       
@@ -4410,5 +4413,5 @@
                 DO  k = nzb_soil, nzt_soil
                    IF ( surf_lsm_v(l)%pavement_surface(m)  .AND.               &
-                        k <= surf_lsm_h%nzt_pavement(m) )  THEN
+                        k <= surf_lsm_v(l)%nzt_pavement(m) )  THEN
                       surf_lsm_v(l)%root_fr(k,m) = 0.0_wp
                    ELSE
@@ -4692,7 +4695,7 @@
           ALLOCATE ( surf_lsm_v(l)%water_surface(1:surf_lsm_v(l)%ns)       )
 
-          surf_lsm_v(l)%water_surface     = .FALSE.
-          surf_lsm_v(l)%pavement_surface  = .FALSE.
-          surf_lsm_v(l)%vegetation_surface   = .FALSE. 
+          surf_lsm_v(l)%water_surface       = .FALSE.
+          surf_lsm_v(l)%pavement_surface    = .FALSE.
+          surf_lsm_v(l)%vegetation_surface  = .FALSE. 
           
 
Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3051)
@@ -25,8 +25,15 @@
 ! -----------------
 ! $Id$
-! Error messages revised
+! - Speed-up NetCDF input
+! - Revise input routines and remove NetCDF input via IO-blocks since this is 
+!   not working in parallel mode in case blocking collective read operations 
+!   are done 
+! - Temporarily revoke renaming of input variables in dynamic driver (tend_ug, 
+!   tend_vg, zsoil) in order to keep dynamic input file working with current 
+!   model version
+! - More detailed error messages created
 ! 
 ! 3045 2018-05-28 07:55:41Z Giersch
-! Error message revised
+! Error messages revised
 ! 
 ! 3041 2018-05-25 10:39:54Z gronemeier
@@ -563,5 +570,6 @@
        MODULE PROCEDURE get_variable_3d_int8
        MODULE PROCEDURE get_variable_3d_real
-       MODULE PROCEDURE get_variable_3d_real_v
+       MODULE PROCEDURE get_variable_3d_real_dynamic
+!        MODULE PROCEDURE get_variable_3d_real_v
        MODULE PROCEDURE get_variable_4d_real
     END INTERFACE get_variable
@@ -647,47 +655,46 @@
        IF ( .NOT. input_pids_static )  RETURN
 
-       DO  ii = 0, io_blocks-1
-          IF ( ii == io_group )  THEN
 #if defined ( __netcdf )
 !
-!--          Open file in read-only mode
-             CALL open_read_file( TRIM( input_file_static ) //                 &
-                                  TRIM( coupling_char ), id_mod )
-!
-!--          Read global attributes
-             CALL get_attribute( id_mod, input_file_atts%origin_lat_char,      &
-                                 input_file_atts%origin_lat, .TRUE. )
-
-             CALL get_attribute( id_mod, input_file_atts%origin_lon_char,      &
-                                 input_file_atts%origin_lon, .TRUE. )
-
-             CALL get_attribute( id_mod, input_file_atts%origin_time_char,     &
-                                 input_file_atts%origin_time, .TRUE. )
-
-             CALL get_attribute( id_mod, input_file_atts%origin_x_char,        &
-                                 input_file_atts%origin_x, .TRUE. )
-
-             CALL get_attribute( id_mod, input_file_atts%origin_y_char,        &
-                                 input_file_atts%origin_y, .TRUE. )
-
-             CALL get_attribute( id_mod, input_file_atts%origin_z_char,        &
-                                 input_file_atts%origin_z, .TRUE. )
-
-             CALL get_attribute( id_mod, input_file_atts%rotation_angle_char,  &
-                                 input_file_atts%rotation_angle, .TRUE. )
-
-!
-!--          Finally, close input file
-             CALL close_input_file( id_mod )
-!
-!--          Copy lon/lat values
-             init_model%latitude = input_file_atts%origin_lat
-             init_model%longitude = input_file_atts%origin_lon
+!--    Open file in read-only mode
+       CALL open_read_file( TRIM( input_file_static ) //                       &
+                            TRIM( coupling_char ), id_mod )
+!
+!--    Read global attributes
+       CALL get_attribute( id_mod, input_file_atts%origin_lat_char,            &
+                           input_file_atts%origin_lat, .TRUE. )
+
+       CALL get_attribute( id_mod, input_file_atts%origin_lon_char,            &
+                           input_file_atts%origin_lon, .TRUE. )
+
+       CALL get_attribute( id_mod, input_file_atts%origin_time_char,           &
+                           input_file_atts%origin_time, .TRUE. )
+
+       CALL get_attribute( id_mod, input_file_atts%origin_x_char,              &
+                           input_file_atts%origin_x, .TRUE. )
+
+       CALL get_attribute( id_mod, input_file_atts%origin_y_char,              &
+                           input_file_atts%origin_y, .TRUE. )
+
+       CALL get_attribute( id_mod, input_file_atts%origin_z_char,              &
+                           input_file_atts%origin_z, .TRUE. )
+
+       CALL get_attribute( id_mod, input_file_atts%rotation_angle_char,        &
+                           input_file_atts%rotation_angle, .TRUE. )
+
+!
+!--    Finally, close input file
+       CALL close_input_file( id_mod )
 #endif
-          ENDIF
-#if defined( __parallel )
-          CALL MPI_BARRIER( comm2d, ierr )
-#endif
-       ENDDO
+!
+!--    Copy latitude, longitude, origin_z, rotation angle on init type
+       init_model%latitude        = input_file_atts%origin_lat
+       init_model%longitude       = input_file_atts%origin_lon
+       init_model%origin_time     = input_file_atts%origin_time  
+       init_model%origin_x        = input_file_atts%origin_x
+       init_model%origin_y        = input_file_atts%origin_y
+       init_model%origin_z        = input_file_atts%origin_z  
+       init_model%rotation_angle  = input_file_atts%rotation_angle  
+            
 !
 !--    In case of nested runs, each model domain might have different longitude
@@ -697,5 +704,5 @@
 !--    synchronization is required already here.
 #if defined( __parallel )
-       CALL MPI_BCAST( init_model%latitude, 1, MPI_REAL, 0,                    &
+       CALL MPI_BCAST( init_model%latitude,  1, MPI_REAL, 0,                   &
                        MPI_COMM_WORLD, ierr )
        CALL MPI_BCAST( init_model%longitude, 1, MPI_REAL, 0,                   &
@@ -725,8 +732,5 @@
        CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names  !< variable names in static input file
 
-       INTEGER(iwp) ::  i         !< running index along x-direction
-       INTEGER(iwp) ::  ii        !< running index for IO blocks
        INTEGER(iwp) ::  id_surf   !< NetCDF id of input file
-       INTEGER(iwp) ::  j         !< running index along y-direction
        INTEGER(iwp) ::  k         !< running index along z-direction
        INTEGER(iwp) ::  k2        !< running index
@@ -751,109 +755,99 @@
 !--    Read plant canopy variables.
        IF ( plant_canopy )  THEN
-          DO  ii = 0, io_blocks-1
-             IF ( ii == io_group )  THEN
 #if defined ( __netcdf )
 !
-!--             Open file in read-only mode
-                CALL open_read_file( TRIM( input_file_static ) //              &
-                                     TRIM( coupling_char ) , id_surf )
-!
-!--             At first, inquire all variable names.
-!--             This will be used to check whether an optional input variable
-!--             exist or not.
-                CALL inquire_num_variables( id_surf, num_vars )
-
-                ALLOCATE( var_names(1:num_vars) )
-                CALL inquire_variable_names( id_surf, var_names )
-
-!
-!--             Read leaf area density - resolved vegetation
-                IF ( check_existence( var_names, 'lad' ) )  THEN
-                   leaf_area_density_f%from_file = .TRUE.
-                   CALL get_attribute( id_surf, char_fill,                     &
-                                       leaf_area_density_f%fill,               &
-                                       .FALSE., 'lad' )
-!
-!--                Inquire number of vertical vegetation layer
-                   CALL get_dimension_length( id_surf, leaf_area_density_f%nz, &
-                                              'zlad' )
-!
-!--                Allocate variable for leaf-area density
-                   ALLOCATE( leaf_area_density_f%var(                          &
-                                                   0:leaf_area_density_f%nz-1, &
-                                                   nys:nyn,nxl:nxr) )
-
-                   CALL get_variable( id_surf, 'lad',      &
-                                      nxl, nxr, nys, nyn,                &
-                                      leaf_area_density_f%var(:,nys:nyn, nxl:nxr) )
-
-                ELSE
-                   leaf_area_density_f%from_file = .FALSE.
-                ENDIF
-
-!
-!--             Read basal area density - resolved vegetation
-                IF ( check_existence( var_names, 'bad' ) )  THEN
-                   basal_area_density_f%from_file = .TRUE.
-                   CALL get_attribute( id_surf, char_fill,                     &
-                                       basal_area_density_f%fill,              &
-                                       .FALSE., 'bad' )
-!
-!--                Inquire number of vertical vegetation layer
-                   CALL get_dimension_length( id_surf,                         &
-                                              basal_area_density_f%nz,         &
-                                              'zlad' )
-!
-!--                Allocate variable
-                   ALLOCATE( basal_area_density_f%var(                         &
-                                                  0:basal_area_density_f%nz-1, &
-                                                  nys:nyn,nxl:nxr) )
-
-                   CALL get_variable( id_surf, 'bad',                    &
-                                      nxl, nxr, nys, nyn,                &
-                                      basal_area_density_f%var(:,nys:nyn, nxl:nxr) )
-                ELSE
-                   basal_area_density_f%from_file = .FALSE.
-                ENDIF
-
-!
-!--             Read root area density - resolved vegetation
-                IF ( check_existence( var_names, 'root_area_dens_r' ) )  THEN
-                   root_area_density_lad_f%from_file = .TRUE.
-                   CALL get_attribute( id_surf, char_fill,                     &
-                                       root_area_density_lad_f%fill,           &
-                                       .FALSE., 'root_area_dens_r' )
-!
-!--                Inquire number of vertical soil layers
-                   CALL get_dimension_length( id_surf,                         &
-                                              root_area_density_lad_f%nz,      &
-                                              'zsoil' )
-!
-!--                Allocate variable
-                   ALLOCATE( root_area_density_lad_f%var                       &
-                                               (0:root_area_density_lad_f%nz-1,&
+!--       Open file in read-only mode
+          CALL open_read_file( TRIM( input_file_static ) //                    &
+                               TRIM( coupling_char ) , id_surf )
+!
+!--       At first, inquire all variable names.
+!--       This will be used to check whether an optional input variable
+!--       exist or not.
+          CALL inquire_num_variables( id_surf, num_vars )
+
+          ALLOCATE( var_names(1:num_vars) )
+          CALL inquire_variable_names( id_surf, var_names )
+
+!
+!--       Read leaf area density - resolved vegetation
+          IF ( check_existence( var_names, 'lad' ) )  THEN
+             leaf_area_density_f%from_file = .TRUE.
+             CALL get_attribute( id_surf, char_fill,                           &
+                                 leaf_area_density_f%fill,                     &
+                                 .FALSE., 'lad' )
+!
+!--          Inquire number of vertical vegetation layer
+             CALL get_dimension_length( id_surf, leaf_area_density_f%nz,       &
+                                        'zlad' )
+!
+!--          Allocate variable for leaf-area density
+             ALLOCATE( leaf_area_density_f%var( 0:leaf_area_density_f%nz-1,    &
                                                 nys:nyn,nxl:nxr) )
 
-                   CALL get_variable( id_surf, 'root_area_dens_r',  &
-                                      nxl, nxr, nys, nyn,           &
-                                      root_area_density_lad_f%var(:,nys:nyn, nxl:nxr) )
-                ELSE
-                   root_area_density_lad_f%from_file = .FALSE.
-                ENDIF
-!
-!--             Finally, close input file
-                CALL close_input_file( id_surf )
+             CALL get_variable( id_surf, 'lad', leaf_area_density_f%var,       &
+                                nxl, nxr, nys, nyn,                            &
+                                0, leaf_area_density_f%nz-1 )
+
+          ELSE
+             leaf_area_density_f%from_file = .FALSE.
+          ENDIF
+
+!
+!--       Read basal area density - resolved vegetation
+          IF ( check_existence( var_names, 'bad' ) )  THEN
+             basal_area_density_f%from_file = .TRUE.
+             CALL get_attribute( id_surf, char_fill,                           &
+                                 basal_area_density_f%fill,                    &
+                                 .FALSE., 'bad' )
+!
+!--          Inquire number of vertical vegetation layer
+             CALL get_dimension_length( id_surf, basal_area_density_f%nz,      &
+                                        'zlad' )
+!
+!--          Allocate variable
+             ALLOCATE( basal_area_density_f%var(0:basal_area_density_f%nz-1,   &
+                                                nys:nyn,nxl:nxr) )
+
+             CALL get_variable( id_surf, 'bad', basal_area_density_f%var,      &
+                                nxl, nxr, nys, nyn,                            &
+                                0,  basal_area_density_f%nz-1 )
+          ELSE
+             basal_area_density_f%from_file = .FALSE.
+          ENDIF
+
+!
+!--       Read root area density - resolved vegetation
+          IF ( check_existence( var_names, 'root_area_dens_r' ) )  THEN
+             root_area_density_lad_f%from_file = .TRUE.
+             CALL get_attribute( id_surf, char_fill,                           &
+                                 root_area_density_lad_f%fill,                 &
+                                 .FALSE., 'root_area_dens_r' )
+!
+!--          Inquire number of vertical soil layers
+             CALL get_dimension_length( id_surf,                               &
+                                        root_area_density_lad_f%nz,            &
+                                        'zsoil' )
+!
+!--          Allocate variable
+             ALLOCATE( root_area_density_lad_f%var                             &
+                                         (0:root_area_density_lad_f%nz-1,      &
+                                          nys:nyn,nxl:nxr) )
+
+             CALL get_variable( id_surf, 'root_area_dens_r',                   &
+                                root_area_density_lad_f%var,                   &
+                                nxl, nxr, nys, nyn,                            &
+                                0,  root_area_density_lad_f%nz-1 )
+          ELSE
+             root_area_density_lad_f%from_file = .FALSE.
+          ENDIF
+!
+!--       Finally, close input file
+          CALL close_input_file( id_surf )
 #endif
-             ENDIF
-#if defined( __parallel )
-             CALL MPI_BARRIER( comm2d, ierr )
-#endif
-          ENDDO
-!
-!--       Deallocate variable list. Will be re-allocated in case further
-!--       variables are read from file.
-          IF ( ALLOCATED( var_names ) )  DEALLOCATE( var_names )
-
-       ENDIF
+       ENDIF
+!
+!--    Deallocate variable list. Will be re-allocated in case further
+!--    variables are read from file.
+       IF ( ALLOCATED( var_names ) )  DEALLOCATE( var_names )
 !
 !--    Skip the following if no land-surface or urban-surface module are
